﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;


using TwinCAT.Ads;
using TwinCAT.Scope2.Communications;
using TwinCAT.Scope2.View.ScopeViewControlLib;
using System.IO;


namespace CS_Scope3
{
    public partial class DataGridForm : Form
    {
        public int PrtWidth = 0;
        public int PrtHeight = 0;
        public DataGridForm()
        {
            InitializeComponent();
            PrtWidth = this.Width;
            PrtHeight = this.Height;
            this.TopLevel = false;
        }

        //尺寸改变刷新控件
        public void DataGridFrmSizeChange()
        {
            this.Left = 0;
            this.Top = 0;
            this.Width = PrtWidth;
            this.Height = PrtHeight;
        }
        private void DataGridForm_Load(object sender, EventArgs e)
        {

        }

        public void DataGridViewXYFrameFresh(int ChartIndex)
        {
            dataGridView1FrameFresh(ChartIndex);
            dataGridView2FrameFresh(ChartIndex);
        }


        //X Cursor Set && Refresh
        private void dataGridView1FrameFresh(int ChartIndex)
        {
            if (ChartIndex == -1) { return; }
            try
            {
                ScopeViewControlCursor newCursor;
                ScopeViewControlCursor newCursor1;
                ScopeViewControlChannel newChannel;
                               
                dataGridView1.Rows.Clear();
                dataGridView1.Columns.Clear();
                dataGridView1.Columns.Add("Time", "Position");
                dataGridView1.Columns.Add("Cursor", "Cursor");
                int columnIndex = 2;
                GlobalVar.ChartMode = GlobalVar.scopeViewControl1.Charts[ChartIndex].ChartType;

                for (int i = 0; i < GlobalVar.scopeViewControl1.Charts[ChartIndex].Axes.Count; i++)
                {
                    for (int j = 0; j < GlobalVar.scopeViewControl1.Charts[ChartIndex].Axes[i].Channels.Count; j++)
                    {
                        newChannel = GlobalVar.scopeViewControl1.Charts[ChartIndex].Axes[i].Channels[j];
                        string columnName = "Column" + columnIndex.ToString();
                        string coulumnText = newChannel.Acquisition.SymbolName;
                        dataGridView1.Columns.Add(columnName, coulumnText);
                        dataGridView1.Columns[dataGridView1.Columns.Count - 1].DefaultCellStyle.ForeColor = newChannel.Style.Color;
                        columnIndex++;
                    }
                }
                //Set Cursor Event
                for (int i = 0; i < GlobalVar.scopeViewControl1.Charts[ChartIndex].CursorModule.XCursor.Count; i++)
                {
                    newCursor = GlobalVar.scopeViewControl1.Charts[ChartIndex].CursorModule.XCursor[i];
                    newCursor.ChannelValuesChanged += new System.EventHandler(this.resfreshX);//通道中数据变化时刷新
                    newCursor.StatusTimesChanged += new System.EventHandler(this.timeRefreshX);//时间轴变化时自动刷新
                    newCursor.Selected += new System.EventHandler(this.actCursorRefresh); //选中后GridView中显示被选中
                }

                //Set Cursor Frame
                for (int i = 0; i < GlobalVar.scopeViewControl1.Charts[ChartIndex].CursorModule.XCursor.Count; i++)
                {
                    newCursor = GlobalVar.scopeViewControl1.Charts[ChartIndex].CursorModule.XCursor[i];
                     dataGridView1.Rows.Add(newCursor.StatusTimes.ChartPositionTime.ToString(), newCursor.Style.Name);
                    dataGridView1.Rows[i].Cells[1].Style.ForeColor = newCursor.Style.Color;
                    //设置channel的数值
                    for (int j = 0; j < newCursor.ChannelValues.Count; j++)
                    {
                        if (j < dataGridView1.ColumnCount - 2)
                        {
                            dataGridView1[j + 2, i].Value = newCursor.ChannelValues[j];
                        }
                    }
                }
                //Set Delta Frame
                for (int i = 0; i < GlobalVar.scopeViewControl1.Charts[ChartIndex].CursorModule.XCursor.Count - 1; i++)
                {
                    newCursor = GlobalVar.scopeViewControl1.Charts[ChartIndex].CursorModule.XCursor[i];
                    for (int j = i + 1; j < GlobalVar.scopeViewControl1.Charts[ChartIndex].CursorModule.XCursor.Count; j++)
                    {
                        newCursor1 = GlobalVar.scopeViewControl1.Charts[ChartIndex].CursorModule.XCursor[j];
                        string str = (TimeSpan.Parse(dataGridView1[0, i].Value.ToString()) - TimeSpan.Parse
                        (dataGridView1[0, j].Value.ToString())).ToString();
                        dataGridView1.Rows.Add(str, newCursor.Style.Name + "-" + newCursor1.Style.Name);
                        //设置channel的delta数值
                        int RowsNum = dataGridView1.Rows.Count;
                        for (int k = 0; k < newCursor.ChannelValues.Count; k++)
                        {
                            if (k < dataGridView1.ColumnCount-2 )
                            {
                                dataGridView1[k + 2, RowsNum - 1].Value = Convert.ToDouble(newCursor.ChannelValues[k]) - Convert.ToDouble(newCursor1.ChannelValues[k]);
                            }
                        }

                    }
                }

            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.ToString());
            }


        }
        private void resfreshX(object sender, EventArgs e)
        {
            try
            {
                int index = GlobalVar.TreeViewSelectIndexArray[1];
                if (index == -1) { return; }
                ScopeViewControlCursor tmpCursor = (ScopeViewControlCursor)sender;
                //set new channel value
                for (int k = 0; k < GlobalVar.scopeViewControl1.Charts[index].CursorModule.XCursor.Count; k++)
                {
                    if (GlobalVar.scopeViewControl1.Charts[index].CursorModule.XCursor[k] == tmpCursor)
                    {
                        for (int j = 0; j < tmpCursor.ChannelValues.Count; j++)
                        {
                            dataGridView1[j + 2, k].Value = tmpCursor.ChannelValues[j];
                        }
                        break;
                    }
                }
                //refresh all delta values
                int m = GlobalVar.scopeViewControl1.Charts[index].CursorModule.XCursor.Count;
                for (int i = 0; i < GlobalVar.scopeViewControl1.Charts[index].CursorModule.XCursor.Count; i++)
                {
                    for (int k = i + 1; k < GlobalVar.scopeViewControl1.Charts[index].CursorModule.XCursor.Count; k++)
                    {
                        for (int h = 2; h < GlobalVar.scopeViewControl1.Charts[index].Axes[0].Channels.Count + 2; h++)
                        {
                            if (dataGridView1[h, k].Value != null)
                            {
                                dataGridView1[h, m].Value = Convert.ToDouble(dataGridView1[h, i].Value) -
                                    Convert.ToDouble(dataGridView1[h, k].Value);
                            }
                        }
                        m++;
                    }
                }
            }
            catch (Exception) { }
        }
        private void timeRefreshX(object sender, EventArgs e)
        {
            int index = GlobalVar.TreeViewSelectIndexArray[1];
            if (index == -1) { return; }

            //refresh the cursortime
            for (int i = 0; i < GlobalVar.scopeViewControl1.Charts[index].CursorModule.XCursor.Count; i++)
            {
                dataGridView1[0, i].Value = GlobalVar.scopeViewControl1.Charts[index].CursorModule.XCursor[i].StatusTimes.ChartPositionTime.
                ToString();
            }
            //refresh the deltatime
            int m = GlobalVar.scopeViewControl1.Charts[index].CursorModule.XCursor.Count;
            for (int i = 0; i < GlobalVar.scopeViewControl1.Charts[index].CursorModule.XCursor.Count; i++)
            {
                for (int k = i + 1; k < GlobalVar.scopeViewControl1.Charts[index].CursorModule.XCursor.Count; k++)
                {
                    dataGridView1[0, m].Value = TimeSpan.Parse(dataGridView1[0, i].Value.ToString()) - TimeSpan.Parse(
                    dataGridView1[0, k].Value.ToString());
                    m++;
                }
            }
        }

       
        //YCursor Set && Refresh
        private void dataGridView2FrameFresh(int ChartIndex)
        {
            if (ChartIndex == -1) { return; }
            try
            {
                dataGridView2.Rows.Clear();
                ScopeViewControlCursor newCursor;
                ScopeViewControlCursor newCursor1;

                //Set Cursor Event
                for (int i = 0; i < GlobalVar.scopeViewControl1.Charts[ChartIndex].CursorModule.YCursor.Count; i++)
                {
                    newCursor = GlobalVar.scopeViewControl1.Charts[ChartIndex].CursorModule.YCursor[i];
                    newCursor.AxesValuesChanged += new System.EventHandler(this.resfreshY);//当坐标轴数值自动刷新时执行
                    newCursor.Selected += new System.EventHandler(this.actCursorRefresh); //选中后GridView中显示被选中
                }

                //Set Cursor Frame
                for (int i = 0; i < GlobalVar.scopeViewControl1.Charts[ChartIndex].CursorModule.YCursor.Count; i++)
                {
                    newCursor = GlobalVar.scopeViewControl1.Charts[ChartIndex].CursorModule.YCursor[i];
                    if (newCursor.AxesValues.Count > 0)
                    {
                        dataGridView2.Rows.Add(newCursor.Style.Name, newCursor.AxesValues[0]);
                    }
                    else
                    {
                        dataGridView2.Rows.Add(newCursor.Style.Name, 0);
                    }
                    dataGridView2.Rows[i].DefaultCellStyle.ForeColor = newCursor.Style.Color;
                }
                //Set Delta Frame
                for (int i = 0; i < GlobalVar.scopeViewControl1.Charts[ChartIndex].CursorModule.YCursor.Count - 1; i++)
                {
                    newCursor = GlobalVar.scopeViewControl1.Charts[ChartIndex].CursorModule.YCursor[i];
                    for (int j = i + 1; j < GlobalVar.scopeViewControl1.Charts[ChartIndex].CursorModule.YCursor.Count; j++)
                    {
                        newCursor1 = GlobalVar.scopeViewControl1.Charts[ChartIndex].CursorModule.YCursor[j];
                        if (newCursor.AxesValues.Count > 0)
                        {
                            dataGridView2.Rows.Add(newCursor.Style.Name + "-" + newCursor1.Style.Name,
                                newCursor.AxesValues[0] - newCursor1.AxesValues[0]);
                        }
                        else
                        {
                            dataGridView2.Rows.Add(newCursor.Style.Name + "-" + newCursor1.Style.Name,
                              0);
                        }

                    }
                }

            }
            catch (Exception exp)
            {

                MessageBox.Show(exp.ToString());
            }

        }
        private void resfreshY(object sender, EventArgs e)
        {
            try
            {
                int index = GlobalVar.TreeViewSelectIndexArray[1];
                if (index == -1) { return; }
                ScopeViewControlCursor tmpCursor = (ScopeViewControlCursor)sender;

                //刷新Axis数值
                for (int i = 0; i < dataGridView2.Rows.Count; i++)
                {
                    if (dataGridView2[0, i].Value.ToString() == tmpCursor.Style.Name)
                    {
                        dataGridView2[1, i].Value = tmpCursor.AxesValues[0].ToString();
                        break;
                    }
                }
                //刷新所有的Delta数值
                int m = GlobalVar.scopeViewControl1.Charts[index].CursorModule.YCursor.Count;
                for (int i = 0; i < GlobalVar.scopeViewControl1.Charts[index].CursorModule.YCursor.Count; i++)
                {
                    for (int k = i + 1; k < GlobalVar.scopeViewControl1.Charts[index].CursorModule.YCursor.Count; k++)
                    {
                        dataGridView2[1, m].Value = Convert.ToDouble(dataGridView2[1, i].Value) -
                            Convert.ToDouble(dataGridView2[1, k].Value);
                    }
                    m++;
                }
            }
            catch (Exception) { }
        }

        //选中对用的Cursor，相应的datagridview中显示为被选状态
        private void actCursorRefresh(object sender, EventArgs e)
        {
            int index = GlobalVar.TreeViewSelectIndexArray[1];
            if (index == -1) { return; }
            ScopeViewControlCursor tmpCursor = (ScopeViewControlCursor)sender;

            if (tmpCursor.Style.Orientation == TwinCAT.Scope2.Charting.ChartingBase.CursorDirection.Vertical)
            {
                for (int i = 0; i < GlobalVar.scopeViewControl1.Charts[index].CursorModule.XCursor.Count; i++)
                {
                    if (tmpCursor == GlobalVar.scopeViewControl1.Charts[index].CursorModule.XCursor[i])
                    {
                        dataGridView1.ClearSelection();
                        dataGridView1.Rows[i].Selected = true;
                    }
                }
            }
            else
            {
                for (int i = 0; i < GlobalVar.scopeViewControl1.Charts[index].CursorModule.YCursor.Count; i++)
                {
                    if (tmpCursor == GlobalVar.scopeViewControl1.Charts[index].CursorModule.YCursor[i])
                    {
                        dataGridView2.ClearSelection();
                        dataGridView2.Rows[i].Selected = true;
                    }
                }
            }

        }


    }
}
