﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using TwinCAT.Ads;
using TwinCAT.Scope2.Communications;
using TwinCAT.Scope2.View.ScopeViewControlLib;
using System.IO;

namespace CS_Scope3
{
    public partial class PropertyForm : Form
    {

        public int PrtWidth = 0;
        public int PrtHeight = 0;

        public PropertyForm()
        {
            InitializeComponent();
            this.TopLevel = false;//取消界面的TopLevel，否则添加不到Panel中
            PrtWidth = this.Width;
            PrtHeight = this.Height;
        }
        //控件尺寸改变
        public void PropertyFormSizeChange()
        {
            this.Left = 0;
            this.Top = 0;
            this.Width = PrtWidth;
            this.Height = PrtHeight;
            label2.Width = this.Width;
            propertyGrid1.Height = this.Height - label2.Bottom;
            comboBox1.Left = this.Width - comboBox1.Width;
            comboBox1.Top = propertyGrid1.Top;
        }

        private void PropertyForm_Load(object sender, EventArgs e)
        {

        }

        public void RefreshCombobox(int index)
        {
            //显示当前节点名称
            label2.Text = GlobalVar.TreeViewSelectName;
            //针对选中节点的不同Level，调整下拉框的Items
            switch (index)
            {
                case 0:
                    //Project属性
                    comboBox1.Items.Clear();
                    comboBox1.Items.AddRange(new object[] { "Base", "Setting" });
                    break;
                case 1:
                    //Charts属性
                    comboBox1.Items.Clear();
                    comboBox1.Items.AddRange(new object[] { "Base", "Setting" });
                    break;
                case 2:
                    //Axes属性
                    comboBox1.Items.Clear();
                    comboBox1.Items.AddRange(new object[] { "Base", "Setting" });
                    break;
                case 3:
                    //Channels和Cursor属性，其中Cursor没有Acquisitions属性，所以下拉框中的Acquisitions对Cursor无效
                    comboBox1.Items.Clear();
                    if (GlobalVar.ChartMode == scopeDisplayModes.XY)
                    {
                        comboBox1.Items.AddRange(new object[] { "Base", "Setting", "YAcquisitions", "XAcquisitions", });
                    }
                    else
                    {
                        comboBox1.Items.AddRange(new object[] { "Base", "Setting", "Acquisitions" });
                    }

                    break;
                default:
                    comboBox1.Items.Clear();
                    break;
            }
            //将下拉框默认为Base选中
            if (comboBox1.Items.Count > 0)
            {
                comboBox1.SelectedIndex = 0;
            }
        }
        //下拉框选项改变时，属性控件显示对应的属性
        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Project属性
            if (GlobalVar.TreeViewSelectIndexArray[0] >= 0 && GlobalVar.TreeViewSelectIndexArray[1] == -1)
            {
                switch (comboBox1.SelectedIndex)
                {
                    case 0:
                        propertyGrid1.SelectedObject = GlobalVar.scopeViewControl1;
                        break;
                    case 1:
                        propertyGrid1.SelectedObject = GlobalVar.scopeViewControl1.Settings;
                        break;
                    default: break;
                }
            }
            //Charts属性
            if (GlobalVar.TreeViewSelectIndexArray[1] >= 0 && GlobalVar.TreeViewSelectIndexArray[2] == -1)
            {
                switch (comboBox1.SelectedIndex)
                {
                    case 0:
                        propertyGrid1.SelectedObject = GlobalVar.scopeViewControl1.Charts[GlobalVar.TreeViewSelectIndexArray[1]];
                        break;
                    case 1:
                        propertyGrid1.SelectedObject = GlobalVar.scopeViewControl1.Charts[GlobalVar.TreeViewSelectIndexArray[1]].Style;
                        break;
                    //case 2:
                    //    propertyGrid1.SelectedObject = SVC1.Charts[GlobalVar.TreeViewSelectIndexArray[1]].Style;
                    //    break;
                    default: break;
                }
            }
            //Axes属性
            if (GlobalVar.TreeViewSelectIndexArray[2] >= 0 && GlobalVar.TreeViewSelectIndexArray[3] == -1)
            {
                switch (comboBox1.SelectedIndex)
                {
                    case 0:
                        if (!GlobalVar.bTreeViewSelectIsCursor)
                        {
                            propertyGrid1.SelectedObject = GlobalVar.scopeViewControl1.Charts[GlobalVar.TreeViewSelectIndexArray[1]].
                                Axes[GlobalVar.TreeViewSelectIndexArray[2]];
                        }
                        else
                        {
                            propertyGrid1.SelectedObject = GlobalVar.scopeViewControl1.Charts[GlobalVar.TreeViewSelectIndexArray[1]].
                                CursorModule;

                        }
                        break;
                    case 1:
                        if (!GlobalVar.bTreeViewSelectIsCursor)
                        {
                            propertyGrid1.SelectedObject = GlobalVar.scopeViewControl1.Charts[GlobalVar.TreeViewSelectIndexArray[1]].
                                Axes[GlobalVar.TreeViewSelectIndexArray[2]].Style;
                        }
                        else
                        {
                            propertyGrid1.SelectedObject = GlobalVar.scopeViewControl1.Charts[GlobalVar.TreeViewSelectIndexArray[1]].
                                CursorModule;

                        }
                        break;
                    //case 2:
                    //    propertyGrid1.SelectedObject = SVC1.Charts[GlobalVar.TreeViewSelectIndexArray[1]].Axes[GlobalVar.TreeViewSelectIndexArray[2]].Settings;
                    //    break;

                    default: break;
                }
            }
            //Channel、Cursor属性
            if (GlobalVar.TreeViewSelectIndexArray[3] >= 0)
            {
                switch (comboBox1.SelectedIndex)
                {
                    case 0:
                        if (!GlobalVar.bTreeViewSelectIsCursor)
                        {
                            propertyGrid1.SelectedObject = GlobalVar.scopeViewControl1.Charts[GlobalVar.TreeViewSelectIndexArray[1]].
                                Axes[GlobalVar.TreeViewSelectIndexArray[2]].Channels[GlobalVar.TreeViewSelectIndexArray[3]];

                        }
                        else
                        {
                            propertyGrid1.SelectedObject = GlobalVar.scopeViewControl1.Charts[GlobalVar.TreeViewSelectIndexArray[1]].
                                CursorModule.Cursors[GlobalVar.TreeViewSelectIndexArray[3]];
                        }

                        break;
                    case 1:
                        if (!GlobalVar.bTreeViewSelectIsCursor)
                        {
                            propertyGrid1.SelectedObject = GlobalVar.scopeViewControl1.Charts[GlobalVar.TreeViewSelectIndexArray[1]].
                                Axes[GlobalVar.TreeViewSelectIndexArray[2]].Channels[GlobalVar.TreeViewSelectIndexArray[3]].Style;
                        }
                        else
                        {
                            propertyGrid1.SelectedObject = GlobalVar.scopeViewControl1.Charts[GlobalVar.TreeViewSelectIndexArray[1]].
                               CursorModule.Cursors[GlobalVar.TreeViewSelectIndexArray[3]].Style;
                        }

                        break;
                    //case 2:
                    //    propertyGrid1.SelectedObject = SVC1.Charts[GlobalVar.TreeViewSelectIndexArray[1]].Axes[GlobalVar.TreeViewSelectIndexArray[2]].Channels[GlobalVar.TreeViewSelectIndexArray[3]].Settings;
                    //    break;
                    case 2:
                        if (!GlobalVar.bTreeViewSelectIsCursor)
                        {
                            propertyGrid1.SelectedObject = GlobalVar.scopeViewControl1.Charts[GlobalVar.TreeViewSelectIndexArray[1]].
                                Axes[GlobalVar.TreeViewSelectIndexArray[2]].Channels[GlobalVar.TreeViewSelectIndexArray[3]].Acquisition;
                        }
                        break;
                    case 3:
                        if (!GlobalVar.bTreeViewSelectIsCursor)
                        {
                            ScopeViewControlXYChannel XYChannel = (ScopeViewControlXYChannel)(GlobalVar.scopeViewControl1.Charts[GlobalVar.TreeViewSelectIndexArray[1]].
                                Axes[GlobalVar.TreeViewSelectIndexArray[2]].Channels[GlobalVar.TreeViewSelectIndexArray[3]]);
                            propertyGrid1.SelectedObject = XYChannel.XAcquisition;
                        }
                        break;
                    default: break;
                }
            }
        }
        
    }
}
